from FSM import State
import Robot
import ActionCommand
import Info
from skills.AlignGoalSkill import AlignGoalSkill
from skills.TrackBallSkill import TrackBallSkill
from time import time
import math

class AlignGoal(State):

    initialCheck = True
    startTime = 0.0
    goalEither = 8
    goalLeft = 5
    goalRight = 6
    goalBoth = 7
    def onActivate(self):
        initialCheck = True
        self.addBehavior(TrackBallSkill())
        self.addBehavior(AlignGoalSkill())

    def onDeactivate(self):
        self.removeBehavior('TrackBallSkill')
        self.removeBehavior('AlignGoalSkill')

    def step(self):
        #print "x:", Robot.position()['x'], ", y:", Robot.position()['y'], ", theta:", Robot.position()['theta'], ", var:", Robot.position()['variance']
        
        if self.initialCheck:
            if not Info.isFoundBall() or (Info.isFoundBall and Robot.vRrBallLocation()['distance'] > 500):
                self.pop()
                return
            self.startTime = time()
            self.initialCheck = False
        
        post = Robot.postInfo()['which']
        if (post == self.goalLeft or post == self.goalRight or post == self.goalEither) and Robot.position()['theta'] <= math.pi:
            if Robot.postInfo()['pos'][0]['distance'] <= 500:
                self.initialCheck = True
                self.push()
                self.goto('Dribble')
                return
        
        if self.getBehavior('AlignGoalSkill').alignFinished:
            self.initialCheck = True
            self.push()
            self.goto('AlignKick')
            return
        
        #Replace this with a timer    
        if time() - self.startTime >= 15:
            self.initialCheck = True
            self.pop()
            return
        
        # Execute Align Goal
        Info.led().leftEye(0, 1, 0)
        Info.led().rightEye(0, 1, 0)
        
        #print "aligning"
	
        #self.execute('TrackBallSkill')
        self.execute('AlignGoalSkill')
	
