from FSM import State
import Robot
import ActionCommand
import Info
from skills.AlignGoalSkill import AlignGoalSkill
from skills.TrackBallSkill import TrackBallSkill

class AlignGoal(State):
    
    aligning = False
    aligned = False

    def onActivate(self):
        self.addBehavior(TrackBallSkill())
        self.addBehavior(AlignGoalSkill())
        self.aligning = False
        self.aligned = False

    def onDeactivate(self):
        self.removeBehavior('TrackBallSkill')
        self.removeBehavior('AlignGoalSkill')
        self.aligning = False

    def step(self):
        #print "x:", Robot.position()['x'], ", y:", Robot.position()['y'], ", theta:", Robot.position()['theta'], ", var:", Robot.position()['variance']
    
        # Check if need to align
        if not self.aligning:
            if Robot.vRrBallLocation()['distance'] > 300 or not Info.isFoundBall():
                self.pop()
                return
            else:
                self.aligning = True
                
        if self.isAligned():
            self.aligned = True
            self.push()
            self.goto('KickBall')
            return
            
        if self.getBehavior('AlignGoalSkill').alignState == AlignGoalSkill.FAIL:
            self.pop()
            return
        
        # Execute Align Goal
        Info.led().leftEye(0, 1, 0)
        Info.led().rightEye(0, 1, 0)
        
        #print "aligning"
	
        self.execute('TrackBallSkill')
        self.execute('AlignGoalSkill')
	
    def isAligned(self):
        if self.aligned:
            return True
        else:
            if self.aligning:
                return self.getBehavior('AlignGoalSkill').alignState == AlignGoalSkill.FINISHED
            else:
                return False
