from FSM import State
import Robot
import ActionCommand
import Info
from skills.AlignKickSkill import AlignKickSkill
from skills.TrackBallSkill import TrackBallSkill
from skills.ScanForBallSkill import ScanForBallSkill
from time import time

class AlignKick(State):

    initialCheck = True
    startTime = 0.0

    def onActivate(self):
        initialCheck = True
        self.addBehavior(TrackBallSkill())
        self.addBehavior(AlignKickSkill())
        self.addBehavior(ScanForBallSkill())

    def onDeactivate(self):
        self.removeBehavior('TrackBallSkill')
        self.removeBehavior('AlignKickSkill')
        self.removeBehavior('ScanForBallSkill')

    def step(self):
        #print "x:", Robot.position()['x'], ", y:", Robot.position()['y'], ", theta:", Robot.position()['theta'], ", var:", Robot.position()['variance']
        
        if self.initialCheck:
            self.startTime = time()
            self.initialCheck = False
        
        if not Info.isFoundBall():
            self.execute('ScanForBallSkill')
            return
            
        if Info.isFoundBall() and Robot.vRrBallLocation()['distance'] > 500:
            self.pop()
            return
        
        if self.getBehavior('AlignKickSkill').alignFinished:
            self.getBehavior('AlignKickSkill').alignFinished = False
            self.initialCheck = True
            self.push()
            self.goto('KickBall')
            return
        
        #Timeout   
        if time() - self.startTime >= 10:
            self.initialCheck = True
            self.pop()
            return
        
        # Execute Align Kick
        Info.led().leftEye(0, 1, 0)
        Info.led().rightEye(0, 1, 0)
        
        #print "aligning"
	
        self.execute('TrackBallSkill')
        self.execute('AlignKickSkill')
        
