from FSM import State
import Robot
import ActionCommand
import Info
import WhichPosts
from skills.DribbleSkill import DribbleSkill
from skills.TrackBallSkill import TrackBallSkill
from time import time
import math

class Dribble(State):

    initialCheck = True
    startTime = 0.0

    def onActivate(self):
        self.initialCheck = True
        self.addBehavior(DribbleSkill())
        self.addBehavior(TrackBallSkill())

    def onDeactivate(self):
        self.removeBehavior('DribbleSkill')
        self.removeBehavior('TrackBallSkill')

    def step(self):
        if self.initialCheck:
            self.startTime = time()
            self.initialCheck = False
        
        #Replace this with a timer    
        if time() - self.startTime >= 3:
            self.initialCheck = True
            self.pop()
            return
        
        # Execute Align Goal
        Info.led().leftEye(1, 0, 0)
        Info.led().rightEye(1, 0, 0)
        
        #print "aligning"
	
        self.execute('DribbleSkill')
        self.execute('TrackBallSkill')
	
