from FSM import State
import Robot
import ActionCommand
import Info
import Util
from skills.TrackBallSkill import TrackBallSkill
from skills.WalkToBallSkill import WalkToBallSkill
from skills.CheckGoal import CheckGoal
import RoleCheck
from time import time

class GoToBall(State):

    isLocalizing = False
    initialTime = 0.0

    def onActivate(self):
        self.isLocalizing = False
        self.initialTime = time()
        self.addBehavior(TrackBallSkill())
        self.addBehavior(WalkToBallSkill())
        self.addBehavior(CheckGoal())
        
    def onDeactivate(self):
        self.isLocalizing = False
        self.removeBehavior('TrackBallSkill')
        self.removeBehavior('WalkToBallSkill')
        self.removeBehavior('CheckGoal')
    
    def step(self):
   
        #RoleCheck.checkStriker()
        
        if self.isLocalizing:
            self.execute('CheckGoal')
            Util.move(1000, 0, 0.0)
            if self.getBehavior('CheckGoal').finished == True:
                self.initialTime = time()
                self.isLocalizing = False
        else:
            if not Info.isFoundBall():
                self.pop()
                return
            elif Info.isFoundBall() and Robot.vRrBallLocation()['distance'] < 225:
                self.push()
                self.goto('AlignGoal')
                return
                
            if time() - self.initialTime >= 2 and Robot.vRrBallLocation()['distance'] > 750:
                #self.isLocalizing = True
                self.isLocalizing = False
            print "x:", Robot.position()['x'], ", y:", Robot.position()['y'], ", theta:", Robot.position()['theta'], ", var:", Robot.position()['variance']
            #print "gotoball"
		    
            # Execute Kick Ball
            Info.led().leftEye(0, 0, 1)
            Info.led().rightEye(0, 0, 1)
            
            self.execute('TrackBallSkill')
            self.execute('WalkToBallSkill')

        
