from FSM import State
import Robot
import ActionCommand
import Info
from skills.AlignKickSkill import AlignKickSkill
from skills.TrackBallSkill import TrackBallSkill
from time import time

class GoalieAlignClear(State):

    initialCheck = True
    startTime = 0.0

    def onActivate(self):
        initialCheck = True
        self.addBehavior(TrackBallSkill())
        self.addBehavior(AlignKickSkill())

    def onDeactivate(self):
        self.removeBehavior('TrackBallSkill')
        self.removeBehavior('AlignKickSkill')

    def step(self):        
        if self.initialCheck:
            self.startTime = time()
            self.initialCheck = False
        
        if (not Info.isFoundBall()) or (Info.isFoundBall() and Robot.vRrBallLocation()['distance'] > 500):
            self.pop()
            return
        
        if self.getBehavior('AlignKickSkill').alignFinished:
            self.getBehavior('AlignKickSkill').alignFinished = False
            self.initialCheck = True
            self.push()
            self.goto('GoalieClear')
            return
        
        #Timeout   
        if time() - self.startTime >= 10:
            self.initialCheck = True
            self.pop()
            return
        
        # Execute Align Kick
        Info.led().leftEye(0, 1, 0)
        Info.led().rightEye(0, 1, 0)
        
        #print "aligning"
	
        self.execute('TrackBallSkill')
        self.execute('AlignKickSkill')
        
