# Main goalie state

from FSM import State
import Robot
import ActionCommand
import Info
from skills.GoalieAlign import GoalieAlign
from skills.TrackBallSkill import TrackBallSkill
from skills.ReturnToGoal import ReturnToGoal
from skills.HeadScan import HeadScan
from time import time

class Goalie(State):    
    
    kicking = False
    n = 0
    alignTime = 0.0
    REALIGN_MAX = 10
    
    def onActivate(self):
        self.addBehavior(GoalieAlign())
        self.addBehavior(TrackBallSkill())
        self.addBehavior(ReturnToGoal())
        self.addBehavior(HeadScan())
        self.kicking = False
        self.n = 0
        self.alignTime = time()
    
    def onDeactivate(self):
        self.removeBehavior('GoalieAlign')
        self.removeBehavior('TrackBallSkill')
        self.removeBehavior('ReturnToGoal')
        self.removeBehavior('HeadScan')
        self.kicking = False
        self.n = 0
        
    def step(self):
    
        #print "Realign Counter: ", self.alignCounter

        if self.kicking == False:
            self.n = 0
            '''
            #Periodically realign to the center of the goal
            if time() - self.alignTime >= self.REALIGN_MAX:
                self.alignTime = time()
                self.push()
                self.goto('GoalieRealign')
                return
            '''
            
            #Find the ball
            if not Info.isFoundBall():
                self.execute('HeadScan')
                return
            
            #Stay in front of the ball with lateral movement
            self.execute('GoalieAlign')
            if self.getBehavior('GoalieAlign').kickState == True:
                self.kicking = True
                
            self.execute('TrackBallSkill') 
        
        #Clear ball from goal area
        else:
            print "Kicking"
            #Check to make sure own goal is not in sight
            post = Robot.postInfo()['which']
            if (Info.getTeamColor == Info.BLUE and (post == BLUE_BOTH or post == BLUE_LEFT or post == BLUE_RIGHT or post == BLUE_EITHER)) or (Info.getTeamColor == Info.RED and (post == YELLOW_BOTH or post == YELLOW_LEFT or post == YELLOW_RIGHT or post == YELLOW_EITHER)):
                print "Aimed at my own goal!"
            else:
                Info.body().actionType(ActionCommand.Body.KICK)
                if self.getBehavior('GoalieAlign').kickingLeft == True:
                    Info.body().left(50)
                else:
                    Info.body().left(-50)
            
            if self.n == 100:
                self.kicking = False
                self.n = 0
            self.n += 1
        

