# Goalie state that brings the goalie back to its position in front of the goal and
# facing forward

from FSM import State
import Robot
import ActionCommand
from skills.ScanForGoalSkill import ScanForGoalSkill
import Info
import WhichPosts
import math
from time import time

class GoalieRealign(State):
    startTime = 0.0
    timeout = 15
    
    
    def onActivate(self):
        self.startTime = time()
        self.addBehavior(ScanForGoalSkill())
        
    def onDeactivate(self):
        self.removeBehavior('ScanForGoalSkill')
    
    def step(self):
        x = Robot.position()['x']
        y = Robot.position()['y']
        theta = Robot.position()['theta']
        
        #Exit if ball comes into view within 2 meters
        if (Robot.vRrBallLocation()['distance'] < 2000) and (Info.isFoundBall()):
            self.pop()
            return
        
        #Check for timeout
        if time() - self.startTime >= self.timeout:
            self.pop()
            return
        
        self.execute('ScanForGoalSkill')
            
        #Align orientation to face forward
        if theta < radians(270) and theta - radians(90) > radians(10):
            Info.move(0, 0, -2)
        elif theta > radians(270) or (theta < radians(90) and theta - radians(90) < radians(-10)):
            Info.move(0, 0, 2)
        #Align forward and laterally
        else:
            forward = 0
            left = 0
            if x > 100:
                left = -1000
            elif x < -100:
                left = 1000
            if y > -2750:
                forward = -1000
            elif y < -2950:
                forward = 1000
            Info.move(forward, left, 0.0)
            if forward == 0 and left == 0: #finished case
                self.pop()

