from FSM import State
import Robot
import ActionCommand
import Info
import GameController
import math
#from skills.HeadScan import HeadScan
#from skills.ScanForGoalSkill import ScanForGoalSkill

class Initial(State):
    
    def setup(self):
        # Set team color
        if Robot.gcTeam()['teamColour'] == GameController.BLUE:
            Info.setTeamColor(Info.BLUE)
        elif Robot.gcTeam()['teamColour'] == GameController.RED:
            Info.setTeamColor(Info.RED)
            
        # Set player type
        if Robot.player() == 1:
            Info.setPlayerType(Info.GOALIE)
        elif Robot.player() == 2:
            Info.setPlayerType(Info.STRIKER)
        
        self.pressed = False
        
    def onActivate(self):
        Robot.say("Initial State")
        #self.addBehavior(HeadScan())
        #self.addBehavior(ScanForGoalSkill())
    
    def step(self):        
        # Display team color with eyes
        if Info.getTeamColor() == Info.BLUE:
            Info.led().leftEye(0,0,1)
            Info.led().rightEye(0,0,1)
        elif Info.getTeamColor() == Info.RED:
            Info.led().leftEye(1,0,0)
            Info.led().rightEye(1,0,0)
            
        #print Robot.postInfo()['pos'][0]['distance'], Robot.postInfo()['pos'][1]['distance'], Robot.postInfo()['pos'][0]['heading'], Robot.postInfo()['pos'][1]['heading']
        
        # Check left foot sensor
        if Robot.sensorValues()["sensors"][20] or Robot.sensorValues()["sensors"][21]:
            if not self.pressed:
                if Info.getTeamColor() == Info.BLUE:
                    Robot.say("Team Red")
                    Info.setTeamColor(Info.RED)
                elif Info.getTeamColor() == Info.RED:
                    Robot.say("Team Blue")
                    Info.setTeamColor(Info.BLUE)
            self.pressed = True
        else:
            self.pressed = False
        
