import ActionCommand
import Joints
import Robot
import WhichCamera
import GameController
import time
import Info
import Util
from FSM import Behavior
from math import degrees, radians, atan2

class AlignKickSkill(Behavior):

    SHUFFLE_FORWARD = 20
    SHUFFLE_LEFT = 15
    SHUFFLE_TURN = 0.0
    INNER_BOUND = .2
    OUTER_BOUND = .3
    FORWARD_BOUND = 180
    
    alignFinished = False
    kickingLeft = True
    direction = 1

    def setup(self):
        self.alignFinished = False

    def step(self):
        ball = Robot.vRrBallLocation()
        
        forward = 0
        left = 0
        turn = 0.0
        
        if ball['heading'] < 0.0:
            Info.kickingLeft = False
            self.direction = -1
        else:
            Info.kickingLeft = True
            self.direction = 1
        
        if (Info.kickingLeft and ball['heading'] < self.INNER_BOUND) or (not Info.kickingLeft and ball['heading'] > -1 * self.INNER_BOUND):
            left = -1 * self.direction * self.SHUFFLE_LEFT
        elif (Info.kickingLeft and ball['heading'] > self.OUTER_BOUND) or (not Info.kickingLeft and ball['heading'] < -1 * self.OUTER_BOUND):
            left = self.direction * self.SHUFFLE_LEFT
        
        if ball['distance'] > self.FORWARD_BOUND:
            forward = self.SHUFFLE_FORWARD
        
        if (Info.kickingLeft and ball['heading'] >= self.INNER_BOUND and ball['heading'] <= self.OUTER_BOUND) or (not Info.kickingLeft and ball['heading'] <= -1 * self.INNER_BOUND and ball['heading'] >= -1 * self.OUTER_BOUND) and ball['distance'] <= self.FORWARD_BOUND:
            self.alignFinished = True
        
        Util.move(forward, left, turn)

