import ActionCommand
import Joints
import Robot
import WhichPosts
import WhichCamera
import GameController
import time
import math
import Info
from FSM import Behavior
from math import degrees, radians, atan2

class FindGoalSkill(Behavior):
    INIT = 0
    FIND_GOAL = 1
    UPDATE_HEADING = 2
    CENTER_ON_GOAL = 3
    FINISHED = 5

    turnState = 0
    enemyGoalEither = 8
    enemyGoalLeft = 5
    enemyGoalRight = 6
    enemyGoalBoth = 7
    alignState = FIND_GOAL
    updateCounter = 0
    prevHeading = 0
    goalHeading = 0
    postSeen = 8
    timeSpentTurning = 0
    extraTurnCounter = 0
    turnDirection = 1
    globalHeading = 0.0
    timeSpentFindingGoal = 0

    def setup(self):
        self.waypoints = []
        self.waypoints.append((radians(5.0), 0, 0.3, WhichCamera.TOP_CAMERA))  #Bottom
        self.waypoints.append((radians(-3.0), 0, 0.3, WhichCamera.TOP_CAMERA))  #Top
        self.waypoints.append((0, radians(40.0), 0.2, WhichCamera.TOP_CAMERA))    #left
        self.waypoints.append((0, radians(-40.0), 0.2, WhichCamera.TOP_CAMERA))    #right
        self.waypoints.append((0, 0, 0.2, WhichCamera.TOP_CAMERA))    #center
        if Info.getTeamColor() == Info.BLUE:
            self.enemyGoalEither = 8    #Yellow Goal
            self.enemyGoalLeft = 5
            self.enemyGoalRight = 6
            self.enemyGoalBoth = 7
        elif Info.getTeamColor() == Info.RED:
            self.enemyGoalEither = 4    #Blue Goal
            self.enemyGoalLeft = 1
            self.enemyGoalRight = 2
            self.enemyGoalBoth = 3

    def step(self):
        print "Finding Goal"
        
        #print Robot.postInfo()['pos'][0]['heading']
        post = Robot.postInfo()['which']
        self.globalHeading = Robot.position()['theta']
        ''' 
        print self.globalHeading
        '''
        if (Info.getTeamColor == Info.BLUE and self.globalHeading < 0) or (Info.getTeamColor == Info.RED and self.globalHeading > 0):
            self.turnDirection = -1
        else:
            self.turnDirection = 1

        if self.alignState == self.FIND_GOAL:    #turn until enemy goal is found
            self.timeSpentFindingGoal += 1
            self.goalHeading = Robot.postInfo()['pos'][0]['heading']
            if post != self.enemyGoalEither and post != self.enemyGoalLeft and post != self.enemyGoalRight and post != self.enemyGoalBoth and self.extraTurnCounter == 0:
                #print "Finding Goal"
                self.extraTurnCounter = 0            

                #Adjust constats so the robot turns around the ball (carpet dependent)
                Info.body().actionType(ActionCommand.Body.WALK)
                Info.body().forward(0)
                Info.body().turn(math.radians(self.turnDirection * -12))
                Info.body().left(0)    

                Robot.setCamera(self.waypoints[self.turnState][3])
                Info.head().pitch(self.waypoints[self.turnState][0])
                Info.head().yaw(self.waypoints[self.turnState][1] * 1.0)
                Info.head().yawSpeed(self.waypoints[self.turnState][2])
                Info.head().isRelative(False)
                Info.head().pitchSpeed(.2)

                realPitch = Robot.sensorValues()['joints']['angles'][Joints.HeadPitch]
                realYaw = Robot.sensorValues()['joints']['angles'][Joints.HeadYaw]

                if abs(realPitch - Info.head()._pitch) < radians(10) and abs(realYaw - Info.head()._yaw) < radians(10):
                    self.turnState = 1 - self.turnState
            else:
                self.turnState = 2
                self.extraTurnCounter = 0
                self.prevHeading = Robot.postInfo()['pos'][0]['heading']
                #print "Previous Heading: "                
                #print self.prevHeading
                self.alignState = self.FINISHED
