import Joints
import Robot
import ActionCommand
import WhichPosts
import Info
from FSM import Behavior
from math import degrees, radians, atan2

class GoalieAlign(Behavior):
    
    SHUFFLE_FORWARD = 20
    SHUFFLE_LEFT = 15
    SHUFFLE_TURN = 0.0
    INNER_BOUND = .2
    OUTER_BOUND = .3
    FORWARD_BOUND = 200
    
    kickState = False  
    kickingLeft = True  
    counter = 50
    direction = 1
    
    def step(self):
        heading = Robot.vRrBallLocation()['heading']
        distance = Robot.vRrBallLocation()['distance']
        xPos = Robot.position()['x']
        yPos = Robot.position()['y']
        
        self.kickState = False
        
        Info.body().actionType(ActionCommand.Body.WALK)
        
        if self.counter < 50:
            Info.body().forward(0)
            self.direction = int(heading/abs(heading))
            Info.body().left(self.direction * 1000)
            Info.body().turn(0.0)
            self.counter += 1
        else:
            if distance < 500:
                #print "Aligning"
                forward = 0
                left = 0
                turn = 0.0
                
                if ball['heading'] < 0.0:
                    Info.kickingLeft = False
                    self.direction = -1
                else:
                    Info.kickingLeft = True
                    self.direction = 1
                
                if (Info.kickingLeft and ball['heading'] < self.INNER_BOUND) or (not Info.kickingLeft and ball['heading'] > -1 * self.INNER_BOUND):
                    left = -1 * self.direction * self.SHUFFLE_LEFT
                elif (Info.kickingLeft and ball['heading'] > self.OUTER_BOUND) or (not Info.kickingLeft and ball['heading'] < -1 * self.OUTER_BOUND):
                    left = self.direction * self.SHUFFLE_LEFT
                
                if ball['distance'] > self.FORWARD_BOUND:
                    forward = self.SHUFFLE_FORWARD
                
                if (Info.kickingLeft and ball['heading'] >= self.INNER_BOUND and ball['heading'] <= self.OUTER_BOUND) or (not Info.kickingLeft and ball['heading'] <= -1 * self.INNER_BOUND and ball['heading'] >= -1 * self.OUTER_BOUND) and ball['distance'] <= self.FORWARD_BOUND:
                    self.kickState = True
                
                Util.move(forward, left, turn)
            
        if distance < 2000 and distance >= 500:    
            if degrees(abs(heading)) < 10.0:
                if self.counter >= 50:
                    Info.body().turn(0.0)
                    Info.body().forward(0)
                    Info.body().left(0)
                    #print "Blocking"
            else:
                #print "Moving to block"
                Info.body().forward(0)
                self.direction = int(heading/abs(heading))
                Info.body().left(self.direction * 1000)
                Info.body().turn(0.0)
                self.counter = 0
	



