import ActionCommand
import Joints
import Robot
import WhichPosts
import WhichCamera
import GameController
import time
import math
import Info
from FSM import Behavior
from math import degrees, radians, atan2, sin, cos, acos, sqrt

class SkillToTest(Behavior):
    GOAL_WIDTH = 1400.0
    FIELD_LENGTH = 6000.0
    BLUE_GOAL = 3
    YELLOW_GOAL = 7
    BLUE_LEFT = 1
    BLUE_RIGHT = 2
    YELLOW_LEFT = 5
    YELLOW_RIGHT = 6
    X_CORRECTION = 1

    x = 0
    y = 0
    theta = 0

    def setup(self):
        pass

    def step(self):
        posts = Robot.postInfo()['which']
        if (posts == self.BLUE_GOAL) or (posts == self.YELLOW_GOAL):
            print "Saw 2 posts..."            
            #initialization            
            d1 = Robot.postInfo()['pos'][0]['distance']
            d2 = Robot.postInfo()['pos'][1]['distance']
            d3 = self.GOAL_WIDTH
            t1 = Robot.postInfo()['pos'][0]['heading']
            t2 = Robot.postInfo()['pos'][1]['heading']
            
            #calculate position and orientation
            alpha = acos(((d1*d1)-(d2*d2)-(d3*d3))/(-2*d2*d3))
            self.theta = alpha + t2
            self.x = self.X_CORRECTION * (self.GOAL_WIDTH/2.0 - d2*cos(alpha))
            self.y = self.FIELD_LENGTH/2.0 - d2*sin(alpha)
            
            #correct for opposite side of field
            if (posts == self.YELLOW_GOAL):
                self.theta = self.theta + 3.14159
                self.x = -self.x
                self.y = -self.y
            
        elif posts == self.BLUE_LEFT or posts == self.BLUE_RIGHT or posts == self.YELLOW_LEFT or posts == self.YELLOW_RIGHT:
            print "Saw 1 post..."            
            #initialization            
            possibleLocations = []
            i = 0
            d = Robot.postInfo()['pos'][0]['distance']
            t = Robot.postInfo()['pos'][0]['heading']
            
            #populate possible locations (the arc around the post)
            if posts == self.BLUE_LEFT:
                xSign = -1
                ySign = 1
            elif posts == self.BLUE_RIGHT:
                xSign = 1
                ySign = 1
            elif posts == self.YELLOW_LEFT:
                xSign = 1
                ySign = -1
            elif posts == self.YELLOW_RIGHT:
                xSign = -1
                ySign = -1                    
            while i <= 3.14159:
                tempCoord = [xSign*(700 - d*cos(i)), ySign*(3000 - d*sin(i))]
                possibleLocations.append(tempCoord)
                i += 0.0174532925
            
            #find the closest location to the previous (x,y)
            minDist = 999999
            minCoord = [0, 0]
            for j in possibleLocations:
                dist = sqrt((self.x - j[0])*(self.x - j[0]) + (self.y - j[1])*(self.y - j[1]))
                if dist < minDist:
                    minDist = dist
                    minCoord = j
            self.x = minCoord[0]
            self.y = minCoord[1]
            self.theta = atan2(self.y, self.x) + t
        
        else:
            print "Can't see any posts..."

        print "x:", self.x, " y:", self.y, " theta:", self.theta
            
