import ActionCommand
import Joints
import Robot
import WhichPosts
import WhichCamera
import GameController
import time
import math
import Info
from FSM import Behavior
from math import degrees, radians, atan2, sin, cos, acos, sqrt

class SkillToTest(Behavior):
    
    targetX = -1400
    targetY = 500
    targetTheta = 3.14159 / 2.0
    robotTheta = 0
    robotX = 0
    robotY = 0
    
    def step(self):        
        self.robotTheta = Robot.position()['theta']
        self.robotX = Robot.position()['x']
        self.robotY = Robot.position()['y']
        
        print "left: ", Robot.postInfo()['pos'][0]['heading'], "; right: ", Robot.postInfo()['pos'][1]['heading']
        
        if self.robotTheta > 3.14159:
            self.robotTheta -= 2*3.14159
        
        t = atan2(self.targetY - self.robotY, self.targetX - self.robotX)

        distance = sqrt((self.targetY - self.robotY)*(self.targetY - self.robotY) + (self.targetX - self.robotX)*(self.targetX - self.robotX))
        

        if distance <= 250:
            Info.body().actionType(ActionCommand.Body.FAST)
            Info.body().turn(0.0)
            Info.body().forward(0)
            print "DONE"

        else:
            #Turn to fix angle
            if abs(t - self.robotTheta) > .0874:
                theta = self.robotTheta - t
                if theta < 0:
                    theta += 2*3.14159
                
                turnDirection = 1
                if theta <= 3.14159:
                    turnDirection = -1
                
                Info.body().actionType(ActionCommand.Body.FAST)
                Info.body().turn(turnDirection * 10.0)
                if abs(t - self.robotTheta) > 3.14159 / 2.0:
                    Info.body().actionType(ActionCommand.Body.FAST)
                    Info.body().forward(0)
                else:
                    Info.body().actionType(ActionCommand.Body.FAST)
                    Info.body().forward(1000)
            elif distance > 400:
                Info.body().actionType(ActionCommand.Body.FAST)
                Info.body().forward(1000)
                Info.body().turn(0.0)
