#pragma once

#include <boost/shared_ptr.hpp>
#include <alcommon/almodule.h>
#include <string>
#include <pthread.h>
#include <semaphore.h>
#include <alproxies/alvideodeviceproxy.h>
#include <alvision/alimage.h>
#include "libcamera/CameraData.hpp"

namespace AL
{
  class ALBroker;
}

class Camera : public AL::ALModule
{
  public:

    Camera(boost::shared_ptr<AL::ALBroker> broker, const std::string& name);
    virtual ~Camera();

    void init();
    
    static void * CameraThread(void * pArg);

    void GetImage();
    static long long GetTime();

  private:

    AL::ALVideoDeviceProxy fVideoProxy;
    std::string fGVMId;

    AL::ALImage* fImagePointer;
    
    /* Shared Memory */
    int shared_fd;
    CameraData* shared_data;
    sem_t* semaphore1;
    sem_t* semaphore2;
    
    int missedCycles;
    bool fCaptureVideo;
    pthread_t fCameraThread;
};

