
#include "Localiser.hpp"

class KalmanFilter : Localiser {
   friend class LocalisationAdapter;
   public:
   KalmanFilter();

   private:
   /* internal state */
   Odometry prev_odometry;
   bool initialized;
   
   double P[3][3];
   double Q[3][3];
   double R1[3][3]; //Measurement covariance for 1 post
   double R2[3][3]; //Measurement covariance for 2 posts
   double J[3][3];

   /* RobotLocaliser methods */
   Position localise();
   void postLocalise();
   void odometryUpdate();
   double correctAngle(double angle);
   void checkGoal();
};

