
#pragma once

#include <string>

#include "perception/localisation/Localiser.hpp"
#include "perception/localisation/KalmanFilter.hpp"
#include "perception/localisation/particlefilter/ParticleFilter.hpp"
#include "perception/localisation/BallTracker.hpp"
#include "perception/localisation/ObstacleTracker.hpp"
#include "utils/BroadcastData.hpp"
#include "perception/localisation/goalident/GoalIdent.hpp"

/* Adapter that allows Localisation to communicate with the Blackboard */
class LocalisationAdapter {
   public:
   /* The name of the module, must be same as directory name */
   static const std::string name;
   /* Constructor */
   LocalisationAdapter();
   /* Destructor */
   ~LocalisationAdapter();
   
    void populateLocaliser(Localiser*);
   /* One cycle of this thread */
   void tick();
   private:
   /* Filter module instances */
   Localiser *rLocaliser;
   /* Ball Tracker */
   BallTracker B;
   /* Robot Obstacle Tracker */
   ObstacleTracker O;
   
   //void populateLocaliser(Localiser *L);
   GoalIdent *gIdent;
};
