
#pragma once

#include <vector>
#include "utils/Odometry.hpp"
#include "utils/AbsCoord.hpp"
#include "utils/RRCoord.hpp"
#include "utils/ActionCommand.hpp"
#include "utils/RobotObstacle.hpp"
#include "perception/vision/VisionDefs.hpp"
#include "perception/localisation/OdometryCorrection.hpp"
#include "perception/localisation/Position.hpp"
#include "utils/Line.hpp"
#include "gamecontroller/RoboCupGameControlData.hpp"


class Localiser {
   friend class LocalisationAdapter;

   public:
   /* Call this function once data copied in from BB 
    * @return true if a valid position estimate is available */
   virtual Position localise() = 0;
   virtual ~Localiser() {}

   /* IO with blackboard */
   ActionCommand::All acActive;
   Odometry odometry;
   WhichPosts obsWhichPosts;
   RRCoord obsPosts[MAX_POSTS];
   bool obsTeamRed;
   int numRobotPos;
   std::vector<AbsCoord> robotPos;

   RobotType obsRobotTypes[MAX_NUM_ROBOTS];
   RRCoord obsRobotLocations[MAX_NUM_ROBOTS];
   uint16_t obsNumRobots;

   Line seenEdges[MAX_FIELD_EDGES];
   int numSeenEdges;

   int player_number;
   TeamInfo our_team;
};

