
#include "perception/localisation/OdometryCorrection.hpp"

#define ODOMETRY_CORRECTION_X 0.95
#define ODOMETRY_OFFSET_X 0.0
#define ODOMETRY_CORRECTION_Y 1.17
#define ODOMETRY_OFFSET_Y 0.0
#define ODOMETRY_CORRECTION_T 1.25
#define ODOMETRY_OFFSET_T 0.0

double correctForward(double n)
{
    if (n == 0)
        return n;
    else
        return n * ODOMETRY_CORRECTION_Y + ODOMETRY_OFFSET_Y;
}

double correctLeft(double n)
{
    if (n == 0)
        return n;
    else
        return n * ODOMETRY_CORRECTION_X + ODOMETRY_OFFSET_X;
}

double correctTurn(double n)
{
    if (n == 0)
        return n;
    else
        return n * ODOMETRY_CORRECTION_T + ODOMETRY_OFFSET_T;
}

