#include "perception/localisation/Position.hpp"

Position::Position()
{

}

Position::Position(double initialX, double initialY, double initialTheta, double initialProbability)
{
    x = initialX;
    y = initialY;
    theta = initialTheta;
    probability = initialProbability;
}

Position::Position(const Position& source){
	x = source.x;
	y = source.y;
	theta = source.theta;
	probability = source.probability;
}

void Position::copyData(Position toCopy){
	x = toCopy.x;
	y = toCopy.y;
	theta = toCopy.theta;
	probability = toCopy.probability;
}

bool Position::equals(Position test){
	long thisX = x*EQUALS_FACTOR;
	long thisY = y*EQUALS_FACTOR;
	long thisT = theta*EQUALS_FACTOR;
	long thisP = probability*EQUALS_FACTOR;

	long thatX = test.x*EQUALS_FACTOR;
	long thatY = test.y*EQUALS_FACTOR;
	long thatT = test.theta*EQUALS_FACTOR;
	long thatP = test.probability*EQUALS_FACTOR;

	return((thisY==thatY)&&(thisX==thatX)&&(thisT==thatT)&&(thisP==thatP));
}

bool Position::positionEqual(Position test){
	long thisX = x*EQUALS_FACTOR;
	long thisY = y*EQUALS_FACTOR;
	long thisT = theta*EQUALS_FACTOR;

	long thatX = test.x*EQUALS_FACTOR;
	long thatY = test.y*EQUALS_FACTOR;
	long thatT = test.theta*EQUALS_FACTOR;

	return((thisY==thatY)&&(thisX==thatX)&&(thisT==thatT));
}
