
#pragma once

#include "perception/vision/VisionDefs.hpp"
#include "utils/RRCoord.hpp"
#include "utils/AbsCoord.hpp"

#define GREATEST_DIST_FROM_LINE 1150
#define MIN_NUM_FIELD_LINE_POINTS 10

class FieldLineLocalisation {
   public:

      int numFieldLinePoints;
      RRCoord fieldLinePoints[MAX_FIELD_LINE_POINTS];

   private:

      int mapWidth;
      int mapHeight;
      int resolution;
      float *fieldMap;

      // Telescopic search params
      int maxLevel;
      int rangeX[3];
      int rangeY[3];
      float rangeAngle[3];
      int incX[3];
      int incY[3];
      float incAngle[3];

      float cos_a[720];
      float sin_a[720];


      int counterTest;
};
