
#pragma once

#include <string>

#include "perception/localisation/Localiser.hpp"
#include "perception/localisation/RobotLocaliser.hpp"
#include "perception/localisation/BallTracker.hpp"
#include "utils/BroadcastData.hpp"

/* Adapter that allows Localisation to communicate with the Blackboard */
class LocalisationAdapter {
   public:
   /* The name of the module, must be same as directory name */
   static const std::string name;
   /* Constructor */
   LocalisationAdapter();
   /* Destructor */
   ~LocalisationAdapter();
   /* One cycle of this thread */
   void tick();
   private:
   /* Filter module instances */
   Localiser *rLocaliser;
   BallTracker B;
   //void populateLocaliser(Localiser *L);
};
