
#pragma once

#include <vector>
#include "utils/Odometry.hpp"
#include "utils/AbsCoord.hpp"
#include "utils/RRCoord.hpp"
#include "utils/ActionCommand.hpp"
#include "perception/vision/VisionDefs.hpp"
#include "perception/localisation/FieldLineLocalisation.hpp"

class Localiser {
   friend class LocalisationAdapter;

   public:
   /* Call this function once data copied in from BB 
    * @return true if a valid position estimate is available */
   virtual bool localise() = 0;
   virtual ~Localiser() {}

   /* IO with blackboard */
   ActionCommand::All acActive;
   Odometry odometry;
   WhichPosts obsWhichPosts;
   RRCoord obsPosts[MAX_POSTS];
   int numRobotPos;
   std::vector<AbsCoord> robotPos;
};

