
#pragma once

#include <math.h>
#include <vector>
#include <utility>
#include <queue>
#include <algorithm>
#include "perception/localisation/Localiser.hpp"
#include "perception/localisation/LocalisationDefs.hpp"

/* Helps me findout where I am
*/
class PFilter : public Localiser {
   friend class OverviewTab;
   friend class LocalisationReader;
   friend class InverseVision;

   public:
   /**
    * Constructor for localisation module.
    **/
   explicit PFilter();
   /* Destructor */
   ~PFilter();
   
   bool localise();

   // private:

   FieldLineLocalisation fieldLineLocalisation;
   std::vector<AbsCoord> robotLocation;

   /* first observation for the PF */
   bool firstObs;

   bool ourPost;

   Point topLeft;
   Point btmRight;

   unsigned int seed;

   /* a list of particles sorted by weight */
   std::vector<Particle> robotsPF;
};
