#include "GoalIdent.hpp"
#include "blackboard/Blackboard.hpp"
#include <stdlib.h>

GoalIdent::GoalIdent(){}

void GoalIdent::identifyGoal(){
	updateBlackboardReadings();

	if(!noneNull()){return;}

	if(!goalUnidentified()){return;}

	if(goalieBallSightMethod()){
		commitPostChange();
		return;
	}
}

void GoalIdent::updateBlackboardReadings(){
	obsWhichPosts = readFrom(vision, posts);
	readArray(receiver, data, allPlayers);

	for(int i = 0; i < 4; i++){
		if(allPlayers[i].playerNum == 1){
			goalieData = allPlayers[i];
		}
	}

	obsTeamRed = readFrom(gameController, team_red);
	readArray(vision, post, obsPosts);
	readArray(vision, ball, obsBall);
	obsNumBalls = readFrom(vision, numBalls);
}

bool GoalIdent::noneNull(){
	return (allPlayers != NULL)&&(obsPosts != NULL)&&(obsBall != NULL);
}


bool GoalIdent::goalUnidentified(){
	if(obsWhichPosts == NULL){return false;}

	if((obsWhichPosts == pUNKNOWN_EITHER)
			||(obsWhichPosts == pUNKNOWN_LEFT)
			||(obsWhichPosts == pUNKNOWN_RIGHT)
			||(obsWhichPosts == pUNKNOWN_BOTH)){
		return true;
	}

	return false;
}

void GoalIdent::convertToBlue(){
	if(obsWhichPosts == pUNKNOWN_EITHER){
		obsWhichPosts = pBLUE_EITHER;
	}else if(obsWhichPosts == pUNKNOWN_LEFT){
		obsWhichPosts = pBLUE_LEFT;
	}else if(obsWhichPosts == pUNKNOWN_RIGHT){
		obsWhichPosts = pBLUE_RIGHT;
	}else if(obsWhichPosts == pUNKNOWN_BOTH){
		obsWhichPosts = pBLUE_BOTH;
	}
}

void GoalIdent::convertToYellow(){
	if(obsWhichPosts == pUNKNOWN_EITHER){
		obsWhichPosts = pYELLOW_EITHER;
	}else if(obsWhichPosts == pUNKNOWN_LEFT){
		obsWhichPosts = pYELLOW_LEFT;
	}else if(obsWhichPosts == pUNKNOWN_RIGHT){
		obsWhichPosts = pYELLOW_RIGHT;
	}else if(obsWhichPosts == pUNKNOWN_BOTH){
		obsWhichPosts = pYELLOW_BOTH;
	}
}

void GoalIdent::commitPostChange(){
	writeTo(vision, posts, obsWhichPosts);
}


bool GoalIdent::goalieBallSightMethod(){
	//TODO

	//Get Goalie's position and ball location (field side)

	//Ball is in area where it could be on either side of the field, return
	if((goalieData.balldistance < 3500)&&(goalieData.balldistance > 2500)){return false;}
	//No balls seen by this robot, exit
	if(obsNumBalls < 1){return false;}

	bool ball_on_red = (obsTeamRed&&(goalieData.balldistance < 2500))||((!obsTeamRed)&&(goalieData.balldistance > 3500));

	double threshold = 3000 - goalieData.balldistance;
	if(threshold < 0){threshold *= -1;}

	int same_side = 0;

	//Calculate which side of the field the ball is on
	for(int i = 0; i < obsNumBalls; i++){
		//Compare distances given be goalie and this system to possibly determine
		//which side of the field they are on
		if(obsBall[i].distance < threshold){
			same_side += 1;
		}else if(obsBall[i].distance > (goalieData.balldistance + 30)){   //+ 30 is for robot being in corner of friendly side
			same_side -=1;
		}
	}

	//No able to decide, return false
	if(same_side == 0){return false;}

	bool posts_on_same_side = false;

	if(obsPosts[0].distance < 2500){
		posts_on_same_side = true;
	}else if(obsPosts[0].distance > 3500){
		posts_on_same_side = false;
	}else{
		//Posts in gray area
		return false;
	}

	if(same_side > 0){
		if(ball_on_red&&posts_on_same_side){
			convertToYellow();
		}else{
			convertToBlue();
		}
	}else{
		if(ball_on_red&&posts_on_same_side){
			convertToBlue();
		}else{
			convertToYellow();
		}
	}

	//Return true to indicate filtering sucessful
	return true;
}
